# PhasicFlow: nonLinearMod< limited > Class Template Reference

nonLinearMod< limited > Class Template Reference
Collaboration diagram for nonLinearMod< limited >:
[legend]

## Classes

struct | contactForceStorage
struct | nonLinearProperties

## Public Member Functions

| TypeInfoNV (modelName())
INLINE_FUNCTION_HD | nonLinearMod ()
| nonLinearMod (int32 nMaterial, const ViewType1D< real > &rho, const dictionary &dict)
INLINE_FUNCTION_HD | nonLinearMod (const nonLinearMod &)=default
INLINE_FUNCTION_HD | nonLinearMod (nonLinearMod &&)=default
INLINE_FUNCTION_HD nonLinearMod & | operator= (const nonLinearMod &)=default
INLINE_FUNCTION_HD nonLinearMod & | operator= (nonLinearMod &&)=default
INLINE_FUNCTION_HD | ~nonLinearMod ()=default
INLINE_FUNCTION_HD int32 | numMaterial () const
INLINE_FUNCTION_HD void | contactForce (const real dt, const int32 i, const int32 j, const int32 propId_i, const int32 propId_j, const real Ri, const real Rj, const real ovrlp_n, const realx3 &Vr, const realx3 &Nij, contactForceStorage &history, realx3 &FCn, realx3 &FCt) const

## Protected Types

using | NonLinearArrayType = symArray< nonLinearProperties >

## Protected Member Functions

bool | readNonLinearDictionary (const dictionary &dict)

## Static Protected Member Functions

static const char * | modelName ()

## Protected Attributes

int32 | numMaterial_ = 0
ViewType1D< real > | rho_
NonLinearArrayType | nonlinearProperties_

## Detailed Description

### template<bool limited = true>
class pFlow::cfModels::nonLinearMod< limited >

Definition at line 30 of file nonLinearMod.hpp.

## Member Typedef Documentation

## NonLinearArrayType

using NonLinearArrayType = symArray<nonLinearProperties>

protected

Definition at line 66 of file nonLinearMod.hpp.

## Constructor & Destructor Documentation

## nonLinearMod() [1/4]

INLINE_FUNCTION_HD nonLinearMod | ( |  | ) |

inline

Definition at line 154 of file nonLinearMod.hpp.

## nonLinearMod() [2/4]

nonLinearMod | ( | int32 | nMaterial,
|  | const ViewType1D< real > & | rho,
|  | const dictionary & | dict
| ) |  |

inline

Definition at line 156 of file nonLinearMod.hpp.

References fatalExit, nonLinearMod< limited >::readNonLinearDictionary(), and nonLinearMod< limited >::rho_.

Here is the call graph for this function:

## nonLinearMod() [3/4]

INLINE_FUNCTION_HD nonLinearMod | ( | const nonLinearMod< limited > & |  | ) |

default

## nonLinearMod() [4/4]

INLINE_FUNCTION_HD nonLinearMod | ( | nonLinearMod< limited > && |  | ) |

default

## ~nonLinearMod()

INLINE_FUNCTION_HD ~nonLinearMod | ( |  | ) |

default

## Member Function Documentation

## readNonLinearDictionary()

bool readNonLinearDictionary | ( | const dictionary & | dict | ) |

inlineprotected

Definition at line 74 of file nonLinearMod.hpp.

References symArray< T, MemorySpace >::assign(), fatalErrorInFunction, ForAll, symArray< nonLinearProperties >::getN(), dictionary::getVal(), nonLinearMod< limited >::nonlinearProperties_, nonLinearMod< limited >::numMaterial_, and Vector< T, Allocator >::size().

Referenced by nonLinearMod< limited >::nonLinearMod().

Here is the call graph for this function:
Here is the caller graph for this function:

## modelName()

static const char* modelName | ( |  | ) |

inlinestaticprotected

Definition at line 136 of file nonLinearMod.hpp.

## TypeInfoNV()

TypeInfoNV | ( | modelName() |  | ) |

## operator=() [1/2]

INLINE_FUNCTION_HD nonLinearMod& operator= | ( | const nonLinearMod< limited > & |  | ) |

default

## operator=() [2/2]

INLINE_FUNCTION_HD nonLinearMod& operator= | ( | nonLinearMod< limited > && |  | ) |

default

## numMaterial()

INLINE_FUNCTION_HD int32 numMaterial | ( |  | ) | const

inline

Definition at line 190 of file nonLinearMod.hpp.

References nonLinearMod< limited >::numMaterial_.

## contactForce()

INLINE_FUNCTION_HD void contactForce | ( | const real | dt,
|  | const int32 | i,
|  | const int32 | j,
|  | const int32 | propId_i,
|  | const int32 | propId_j,
|  | const real | Ri,
|  | const real | Rj,
|  | const real | ovrlp_n,
|  | const realx3 & | Vr,
|  | const realx3 & | Nij,
|  | contactForceStorage & | history,
|  | realx3 & | FCn,
|  | realx3 & | FCt
| ) |  | const

inline

Definition at line 199 of file nonLinearMod.hpp.

References dot(), length(), nonLinearMod< limited >::nonlinearProperties_, nonLinearMod< limited >::contactForceStorage::overlap_t_, pFlow::Pi, pFlow::pow(), nonLinearMod< limited >::rho_, and pFlow::sqrt().

Here is the call graph for this function:

## Member Data Documentation

## numMaterial_

int32 numMaterial_ = 0

protected

Definition at line 68 of file nonLinearMod.hpp.

Referenced by nonLinearMod< limited >::numMaterial(), and nonLinearMod< limited >::readNonLinearDictionary().

## rho_

ViewType1D<real> rho_

protected

Definition at line 70 of file nonLinearMod.hpp.

Referenced by nonLinearMod< limited >::contactForce(), and nonLinearMod< limited >::nonLinearMod().

## nonlinearProperties_

NonLinearArrayType nonlinearProperties_

protected

Definition at line 72 of file nonLinearMod.hpp.

Referenced by nonLinearMod< limited >::contactForce(), and nonLinearMod< limited >::readNonLinearDictionary().

The documentation for this class was generated from the following file:

- src/Interaction/Models/contactForce/nonLinearMod.hpp